<?php

namespace FiloBlu\GuestWishlist\Controller\Plugin;

class WishlistProvider extends \Magento\Wishlist\Controller\WishlistProvider {

    protected $guestWishlistFactory;
    protected $customerSession;
    protected $_helper;
    
    public function __construct(
    \FiloBlu\GuestWishlist\Model\WishlistFactory $guestWishlistFactory, \Magento\Customer\Model\Session $customerSession, \FiloBlu\GuestWishlist\Helper\Data $helper
    ) {
        $this->_helper = $helper;
        $this->guestWishlistFactory = $guestWishlistFactory;
        $this->customerSession = $customerSession;
    }
    
    public function beforeGetWishlist(\Magento\Wishlist\Controller\WishlistProvider $object, $wishlistId = null) {
        
        # Load guest wishlist by cookie
        if ($this->_helper->getConfig("general/enabled") && !$this->customerSession->isLoggedIn() && !$wishlistId) {
            $wishlist = $this->guestWishlistFactory->create();
            $wishlistId = $wishlist->loadByCookie()->getId();
        }
        return array($wishlistId);

    }

}
