<?php

namespace FiloBlu\GuestWishlist\Model;

use Magento\Wishlist\Model\ItemFactory;
use Magento\Catalog\Api\ProductRepositoryInterface;
use Magento\Wishlist\Model\ResourceModel\Item\CollectionFactory;
use Magento\Wishlist\Model\ResourceModel\Wishlist as ResourceWishlist;
use Magento\Wishlist\Model\ResourceModel\Wishlist\Collection;

class Wishlist extends \Magento\Wishlist\Model\Wishlist {

    protected $_helper;

    public function __construct(
    \Magento\Framework\Model\Context $context, \Magento\Framework\Registry $registry, \Magento\Catalog\Helper\Product $catalogProduct, \Magento\Wishlist\Helper\Data $wishlistData, ResourceWishlist $resource, Collection $resourceCollection, \Magento\Store\Model\StoreManagerInterface $storeManager, \Magento\Framework\Stdlib\DateTime\DateTime $date, ItemFactory $wishlistItemFactory, CollectionFactory $wishlistCollectionFactory, \Magento\Catalog\Model\ProductFactory $productFactory, \Magento\Framework\Math\Random $mathRandom, \Magento\Framework\Stdlib\DateTime $dateTime, ProductRepositoryInterface $productRepository, \FiloBlu\GuestWishlist\Helper\Data $helper, $useCurrentWebsite = true, array $data = []
    ) {
        
        $this->_helper = $helper;
        parent::__construct($context, $registry, $catalogProduct, $wishlistData, $resource, $resourceCollection, $storeManager, $date, $wishlistItemFactory, $wishlistCollectionFactory, $productFactory, $mathRandom, $dateTime, $productRepository);
    }

    
    public function loadByCookie() {
        # Try load wishlist by cookie if exists
        $this->_getResource()->load($this, ($this->_registry->registry("guest_wishlist") ? : $this->_helper->getCookie()), "cookie");

        # If not exists generate new one
        if (!$this->getId()) {
            $this->setCustomerId(NULL);
            $this->setSharingCode($this->_getSharingRandomCode());
            $cookieVal = $this->_getSharingRandomCode();
            $this->setCookie($cookieVal);
            $this->_helper->setCookie($cookieVal);
            $this->_registry->register("guest_wishlist",$cookieVal);
            $this->save();
        }

        return $this;
    }

}
